local HideBlizzard = LibStub("AceAddon-3.0"):GetAddon("HideBlizzard")

local options, moduleOptions = nil, {}
local function opt()
	if not options then
		options = {
			type = "group",
			name = "HideBlizzard",
			get = function() get(info)
				local key = info[#info] 
				return HideBlizzard.db.profile[key]
			end,
			set = function() set(info, value)
				local key = info[#info]
				HideBlizzard.db.profile[key] = value
				HideBlizzard:UpdateView()
			end,
			args = {
				header = {
					type = "description",
					name = "|cffFF3333Version: |r"..GetAddOnMetadata("HideBlizzard", "Version"),
					order = 1,
					fontSize = "medium",
					width = "full",
				},
				spacer = {
					type = "description",
					name = "",
					order = 2,
					width = "full",
				},
				reset = {
					type = "execute",
					name = "reset database",
					order = -1,
					confirm = true,
					func = function() 
						wipe(HideBlizzardDB)
						HideBlizzard:Print("Database has been reset! Changes will take effect when you next login")
					end,
				},
			},
		}
		for k,v in pairs(moduleOptions) do
			options.args[k] = type(v) == "function" and v() or v
		end
	end
	return options
end

function HideBlizzard:RegisterModuleOptions(name, optionTbl, displayName)
	moduleOptions[name] = optionTbl
end

function HideBlizzard:RegisterOptions()
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("HideBlizzard", opt)
	self:RegisterModuleOptions("Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db), "Profiles")

	local function open()
		LibStub("AceConfigDialog-3.0"):Open("HideBlizzard")
	end
	self:RegisterChatCommand("hb", open)
	self:RegisterChatCommand("hideblizz", open)
	self:RegisterChatCommand("hideblizzard", open)
end
